import java.lang.*;
import java.awt.*;


//-----------------------------------------------
// Diese Klasse stellt den Ball-Thread dar
// Autor: ChrM
//-----------------------------------------------


class BallThread implements Runnable {
   
   public Ball b;
   public Collision c;
   public int speed;
   
   BallThread(Ball _b, Collision _c, int _speed) {
      b = _b;
      c = _c; 
      speed = _speed;
   }
   
   public void run() {
      while(true) {
	
	 //Graphics g = c.offscreen;
	 Graphics g = c.getGraphics ();
	 //g.drawImage(c.offscreenImg, 0, 0, c);
	 
	 //-------- Draw Ball -------------
	 if(g != null) {
	    g.setColor(b.color);
	    g.fillOval((int)b.centre.x, (int)b.centre.y, b.radius.intValue() * 2, b.radius.intValue() * 2);
	    g.setColor(Color.white);
	    g.fillOval((int)b.centre.x + b.radius.intValue() / 2, 
		       (int)b.centre.y + b.radius.intValue() / 2, 
		       b.radius.intValue() / 3, 
		       b.radius.intValue() / 3);
	 }
	 	 
	 try {
	    Thread.sleep (speed);
	 }
	 catch (InterruptedException e) {
	 }

	 //-------- Erase -----------------
	 if(g != null) {
	    g.setColor(Color.white);
	    g.fillOval((int)b.centre.x, (int)b.centre.y, b.radius.intValue() * 2, b.radius.intValue() * 2);
	    g.dispose ();	    
	 }
	 	 	 
	 if(b.v1 > 0.01 && b.v1 < 1.7) b.v1 = 1;	 
	 if(b.v2 > 0.01 && b.v2 < 1.7) b.v2 = 1;

	 if(b.centre.x + b.v1 != b.centre.x){
	    b.centre.x += b.v1;
	    b.chDirection = true;
	 }
	    
	 if(b.centre.y + b.v2 != b.centre.x){
	    b.centre.y += b.v2;	 
	    b.chDirection = true;
	 }
      }

   }
}
