import java.applet.*;
import java.awt.*;
import java.awt.geom.Point2D;


//-----------------------------------------------
// Diese Klasse stellt das Applet dar (main)
// Autor: ChrM
//-----------------------------------------------

public class Collision extends Applet {

      //----------- Defaults ---------------
      static final int NUMBER_OF_BALLS = 35;
      static final int RADIUS = 25;
      static final int SPEED = 15;
      //------------------------------------

      Image offscreenImg;
      Graphics offscreen;

   public void init() {

      boolean ok = true;
      this.setBackground(Color.white);
      int myHeight = this.getSize().height;
      int myWidth = this.getSize().width;

      offscreenImg = createImage(myWidth, myHeight);
      offscreen = offscreenImg.getGraphics();
           
      Ball [] ballArray = new Ball [NUMBER_OF_BALLS];	 // All Balls
      
      //-------------------- create Balls and threads ----------------------
      int j = 2, n = 0;
      for(int i = 0; i < NUMBER_OF_BALLS; i++) {
	 n = (i % (myWidth/(RADIUS * 3))) * RADIUS * 3;
	 //System.out.println (n);	 
	 Point2D.Double myPoint = new Point2D.Double (n, j);
	 if(n == 0) j += RADIUS * 3;
	 int myV1 = i%2 + 1;
	 int myV2 = i%2 + 1;
	 Integer myRadius = new Integer (RADIUS);

	 if(j + RADIUS <= myWidth) {
	    Ball myBall = new Ball (myPoint, 
				    (double)myV1, 
				    (double)myV2, 
				    myRadius, 
				    (float)j, 
				    (float)j,
				    (float)j);

	    ballArray [i] = myBall;

	    BallThread t = new BallThread (myBall, this, SPEED);
	    Thread tt = new Thread (t);
	    tt.start();	 
	 }
	 else
	    ok = false;
      }

      
      // ------------------------ create and start controll -----------------
      if(ok) {
	 ControllThread cntrl = new ControllThread (ballArray, myWidth, myHeight, this);
	 Thread tcntrl = new Thread (cntrl);
	 tcntrl.start();
	 tcntrl.setPriority (Thread.MAX_PRIORITY);
      }
      else
	 System.out.println ("Too much balls for this screen size!");

   }
 }



