import java.lang.*;
import java.awt.*;


//-----------------------------------------------
// Diese Klasse stellt den Kontroll-Thread dar
// Autor: ChrM
//-----------------------------------------------


class ControllThread implements Runnable {
   
   public Ball [] bArray;
   public int size_x;
   public int size_y;
   Collision parent;
   
   // C'tor
   ControllThread(Ball [] _bA, int _sx, int _sy, Collision _pa) {
      bArray = _bA;
      size_x = _sx;
      size_y = _sy;
      parent = _pa;
   }

   // Check if two Balls collids
   private boolean collision(Ball b1, Ball b2) {
      double myDistance = Math.sqrt( Math.pow((double)((b1.centre.x + b1.radius.intValue()) - 
				     (b2.centre.x + b2.radius.intValue())), 2) +
				     Math.pow((double)((b1.centre.y + b1.radius.intValue()) - 
				     (b2.centre.y + b2.radius.intValue())), 2)
				   );

      double myDistance2 = Math.sqrt( Math.pow((double)((b1.centre.x + 1 * b1.v1 + b1.radius.intValue()) - 
				      (b2.centre.x + 1 * b2.v1 + b2.radius.intValue())), 2) +
				      Math.pow((double)((b1.centre.y + 1 * b1.v2 + b1.radius.intValue()) - 
				      (b2.centre.y + 1 * b2.v2 + b2.radius.intValue())), 2)
				    );
      
      if( myDistance <= (b1.radius.intValue() + b2.radius.intValue()) &&
	  myDistance2 <= myDistance)
	 return true;
      else
	 return false;
   }         

   // Claculate new vectors
   private void newVectors(Ball b1, Ball b2) {
      Point d = new Point();
      double x1, x2, x3, x4, y1, y2, y3, y4, bruch1, bruch2, en1, en2, eF;
      
      en1 = (b1.v1 * b1.v1) + (b1.v2 * b1.v2) + (b2.v1 * b2.v1) + (b2.v2 * b2.v2);
	 
      /*System.out.println ("Vorher = " + en1);
      System.out.println ("B1: v1 = " + (int)b1.v1 + "; v2 = " + (int)b1.v2);
      System.out.println ("B2: v1 = " + (int)b2.v1 + "; v2 = " + (int)b2.v2);*/
      
      d.x = (int)(b1.centre.x - b2.centre.x);
      d.y = (int)(b1.centre.y - b2.centre.y);

      bruch1 = ((double)d.x * b1.v1 +(double)d.y * b1.v2) / 
	       ((double)d.x * (double)d.x + (double)d.y * (double)d.y);
      bruch2 = ((double)d.x * b2.v1 + (double)d.y * b2.v2) /
	       ((double)d.x * (double)d.x + (double)d.y * (double)d.y);
	    
      x1 = (double)d.x * bruch1;
      y1 = (double)d.y * bruch1;
      
      x2 = b1.v1 - x1;
      y2 = b1.v2 - y1;

      x3 = (double)d.x * bruch2;
      y3 = (double)d.y * bruch2;
      
      x4 = b2.v1 - x3;
      y4 = b2.v2 - y3;

      b1.v1 = (x2 + x3);
      b1.v2 = (y2 + y3);
      
      b2.v1 = (x1 + x4);
      b2.v2 = (y1 + y4); 

      en2 = (b1.v1 * b1.v1) + (b1.v2 * b1.v2) + (b2.v1 * b2.v1) + (b2.v2 * b2.v2);
      eF = Math.sqrt(en1 / en2);

      b1.v1 *= eF;
      b1.v2 *= eF;

      b2.v1 *= eF;
      b2.v2 *= eF;
      
      /*System.out.println ("Nachher = " + en2);
      System.out.println ("B1: v1 = " + (int)b1.v1 + "; v2 = " + (int)b1.v2);
      System.out.println ("B1: v1 = " + (int)b2.v1 + "; v2 = " +(int) b2.v2);*/

   }

   // All this class is living for...
   public void run() {
       while(true)
       {	 
	 for(int i = 0; i < bArray.length; i++) {

	    // Check if Ball is RIGHT out of screen
	    if(bArray[i].centre.x + (bArray[i].radius.intValue() * 2) >= size_x 
		  && bArray[i].chDirection == true) {
		  bArray[i].chDirection = false;
		  if(bArray[i].v1 > 0) bArray[i].v1 = -bArray[i].v1;

	    }

	    // Check if Ball is LEFT out of screen
	    if(bArray[i].centre.x <= 0 &&
	       bArray[i].chDirection == true) {
		  bArray[i].chDirection = false;
		  if(bArray[i].v1 < 0) bArray[i].v1 = -bArray[i].v1;
	    }

  		  
	    // Check if Ball is BOTTOM out of screen
	    if(bArray[i].centre.y + (bArray[i].radius.intValue() * 2) >= size_y &&
	       bArray[i].chDirection == true) {
		  bArray[i].chDirection = false;
		  if(bArray[i].v2 >= 0) bArray[i].v2 = -bArray[i].v2;

	    }
	    
	    // Check if Ball is TOP out of screen
	    if(bArray[i].centre.y <= 0 &&
	       bArray[i].chDirection == true) {
		  bArray[i].chDirection = false;
		  if(bArray[i].v2 <= 0) bArray[i].v2 = -bArray[i].v2;

	    }

	    // Check collision between two Balls (distance)
	    for(int j = 0; j < bArray.length; j++) {
	       if(i != j) {
		  /*if( collision(bArray[i], bArray[j]) ) {*/
		     
		     /*if(  bArray[i].chDirection == true ||
			  bArray[j].chDirection == true)*/ {
			
			// lock direction change before moving
			//bArray[i].chDirection = false;
			//bArray[j].chDirection = false;

			if( collision(bArray[i], bArray[j]) ) {
			   newVectors(bArray[i], bArray[j]);
			}
			
			// lock direction change before moving
			//bArray[i].chDirection = false;
			//bArray[j].chDirection = false;

		     }
		  
	       }
	    }
	       

	 }
	 
	 //System.out.println ("centre0 (y) = " + bArray[0].centre.y);
	 //Graphics g = parent.getGraphics ();
	 //if(g != null) g.drawImage( parent.offscreenImg, 0, 0, null);
	    
	 try {
	    Thread.sleep (0);
	 }
	 catch (InterruptedException e) {
	 }

       }
    }

}

